#!/bin/sh

. #ENVPT3#/bin/protopenv

TMPDIR=${TMPDIR-/tmp}
LOGDIR=${LOGDIR-/tmp}

cd ${PROTOP}

if [ ! -d ${TMPDIR} ]
then
	mkdir ${TMPDIR}
fi

if [ ! -d ${LOGDIR} ]
then
	mkdir ${LOGDIR}
fi

CUSTID=`cat etc/custid.cfg`

if [ -z "${CUSTID}" ]
then
	exit
fi

# actually this is a bad idea -- instead we will allow dbmonitor to start
# and then check the scheduled maintenance end datetime that bin/maintenance.sh
# writes to ${TMPDIR}/MAINTENANCE
#
# if [ -f ${TMPDIR}/MAINTENANCE ]
# then
# 	rm -f ${TMPDIR}/*.flg
# 	exit
# fi


# are we already running?
#

X=`ps -ef | grep "util/dbmonitor.p " | grep _progres | grep "param ${CUSTID} "`

# launch if we are not already running
#

if [ -z "${X}" ]
then

	# all reasonably modern progress versions support -clientlog, -errorstack etc -- if you're trying to
	# install on oe10.0 or v9 or some such crusty old platform we assume that you know what you're doing
	# and can tweak this appropriately

	case "${PROVERSION}" in

		"9")
			$DLC/bin/_progres -1 ${PFLIST} -b -p util/dbmonitor.p -param "${CUSTID}" -T ${TMPDIR} -t >> ${TMPDIR}/dbmonitor.err 2>&1 &
			;;

		*)	# this is a bit optimistic -- some very early 10.x releases did not support -errorstack etc
			# so if you get an error about "-e ..." then you probably need to eliminate -errorstack and
			# -clientlog

			$DLC/bin/_progres -1 ${PFLIST} -b -p util/dbmonitor.p -param "${CUSTID}" -T ${TMPDIR} -t ${ERRSTACK} -clientlog ${TMPDIR}/dbmonitor.debug $* >> ${TMPDIR}/dbmonitor.err 2>&1 &
			;;

	esac

fi

