#!/bin/sh
#
# reaper.sh -- monitor for disconnected _progres sessions
#

SAFEDIR=/tmp

MAILLIST=""			# where to send emails about sessions that have been killed

# ACTION=echo			# useful for testing
ACTION=kill			#  a simple kill, NOT "kill -9"

# TARGET=util/pt3agent.p	# for testing - use ACTION=echo please :)
TARGET=wb/workbook.p		# should be a -p startup procedure that is unique to sessions that might need killing

# if there is no pts/# then it is not connected to a terminal - that plus
# the correct $TARGET is the criteria for qualifying a _progres session
# 

ps -ef | grep [_]progres | grep ${TARGET} | grep -v grep | grep -v " pts/[0-9]" > ${SAFEDIR}/kill.list

if [ -s ${SAFEDIR}/kill.list ]
then

	# echo "found something!"

	echo `date` "${ACTION} ${TARGET}" >> ${SAFEDIR}/kill.log
	cat ${SAFEDIR}/kill.list >> ${SAFEDIR}/kill.log
	echo "" >> ${SAFEDIR}/kill.log

	cat ${SAFEDIR}/kill.list | awk '{print $2}' | xargs ${ACTION} >> ${SAFEDIR}/kill.log
	echo "" >> ${SAFEDIR}/kill.log

	if [ ! -z "${MAILLIST}" ]
	then
		mailx -s "${0} found and ${ACTION}ed _progres sessions" ${MAILLIST} < ${SAFEDIR}/kill.list
	fi

	rm -f ${SAFEDIR}/kill.list

fi
